close all
clc
clear all
alpha_array = [-64 -32 -16 -8 -4 -3 -2 -1.7 -1.5 -1.4 -1.3 -1.2 -1.1 -1 -0.9 -0.8 -0.7 -0.6 -0.5 -0.4 -0.3 -0.2 -0.1 0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 1.1 1.2 1.3 1.4 1.5 1.7 2 3 4 8 16 32 64];
fid = fopen('results.txt', 'w');
fprintf(fid,'State\tObservation\tLength\trpt\tTrial\talpha\tTrue_A\tTrue_B\tEnsemble_A\tEnsemble_B\tRandom_A\tRandom_B\tRabiner_A\tRabiner_B\tAlpha_A\tAlpha_B\tAlpha_noNeg_A\tAlpha_noNeg_B\tAlpha_noSame_A\tAlpha_noSame_B\tAlpha_noSame_noNeg_A\tAlpha_noSame_noNeg_B\n');
fclose(fid);
dataA=[];
dataB=[];
max_itr = 10;
max_itrs=[5 10 20];
max_rpt = 5;
EPS1 = 1e-7;
rowcnt=0;
TestSize=100;
%AUC=zeros(5,2);
AUC_alpha=[0 0];
for M=[4 8 12]
    for N=[5 10 15]
        for T=[5 10 15]
            for rpt=1:max_rpt
                dataA(rowcnt+1:rowcnt+TestSize,1:4)=repmat([M N T rpt],TestSize,1);
                dataB(rowcnt+1:rowcnt+TestSize,1:4)=repmat([M N T rpt],TestSize,1);
                clear testDataA;
                clear testDataB;
                clear trainDataA;
                clear trainDataB;
                clear priorA;
                clear transmatA;
                clear obsmatA;
                clear priorB;
                clear transmatB;
                clear obsmatB;
                trueT=0;
                prior0A = normalise(rand(M,1));
                transmat0A = mk_stochastic(rand(M,M));
                obsmat0A = mk_stochastic(rand(M,N));
                testDataA(1:TestSize,:) = dhmm_sample(prior0A, transmat0A, obsmat0A, TestSize, T);
                trainDataA(1:TestSize,:) = dhmm_sample(prior0A, transmat0A, obsmat0A, TestSize, T);
                logAA=dhmm_logprob(testDataA, prior0A, transmat0A, obsmat0A);
                prior0B = normalise(rand(M,1));
                transmat0B = mk_stochastic(rand(M,M));
                obsmat0B = mk_stochastic(rand(M,N));
                testDataB(1:TestSize,:) = dhmm_sample(prior0B, transmat0B, obsmat0B, TestSize, T);
                trainDataB(1:TestSize,:) = dhmm_sample(prior0B, transmat0B, obsmat0B, TestSize, T);
                logBA=dhmm_logprob(testDataB, prior0A, transmat0A, obsmat0A);
                logAB=dhmm_logprob(testDataA, prior0B, transmat0B, obsmat0B);
                logBB=dhmm_logprob(testDataB, prior0B, transmat0B, obsmat0B);
                cnt=0;
                True_ratio=0.03;
                while((logAA-logBA)/abs(logAA)<True_ratio || (logBB-logAB)/abs(logBB)<True_ratio)
                    trueT=0;
                    cnt=cnt+1;
                    prior0B = normalise(rand(M,1));
                    transmat0B = mk_stochastic(rand(M,M));
                    obsmat0B = mk_stochastic(rand(M,N));
                    testDataB(1:TestSize,:) = dhmm_sample(prior0B, transmat0B, obsmat0B, TestSize, T);
                    trainDataB(1:TestSize,:) = dhmm_sample(prior0B, transmat0B, obsmat0B, TestSize, T);
                    logBA=dhmm_logprob(testDataB, prior0A, transmat0A, obsmat0A);
                    logAB=dhmm_logprob(testDataA, prior0B, transmat0B, obsmat0B);
                    logBB=dhmm_logprob(testDataB, prior0B, transmat0B, obsmat0B);
                    if (cnt>50 && ((logAA-logBA)/abs(logAA)<True_ratio || (logBB-logAB)/abs(logBB)<True_ratio))
                        prior0A = normalise(rand(M,1));
                        transmat0A = mk_stochastic(rand(M,M));
                        obsmat0A = mk_stochastic(rand(M,N));
                        testDataA(1:TestSize,:) = dhmm_sample(prior0A, transmat0A, obsmat0A, TestSize, T);
                        trainDataA(1:TestSize,:) = dhmm_sample(prior0A, transmat0A, obsmat0A, TestSize, T);
                        logAA=dhmm_logprob(testDataA, prior0A, transmat0A, obsmat0A);
                        logBA=dhmm_logprob(testDataB, prior0A, transmat0A, obsmat0A);
                        logAB=dhmm_logprob(testDataA, prior0B, transmat0B, obsmat0B);
                        logBB=dhmm_logprob(testDataB, prior0B, transmat0B, obsmat0B);
                        cnt=0;
                    end
                end
                for j=1:TestSize
                    logA=dhmm_logprob(testDataA(j,:), prior0A, transmat0A, obsmat0A);
                    dataA(rowcnt+j,5)=logA;
                    logB=dhmm_logprob(testDataA(j,:), prior0B, transmat0B, obsmat0B);
                    if (logA>logB)
                        trueT=trueT+1;
                    end
                    logA=dhmm_logprob(testDataB(j,:), prior0A, transmat0A, obsmat0A);
                    logB=dhmm_logprob(testDataB(j,:), prior0B, transmat0B, obsmat0B);
                    dataB(rowcnt+j,5)=logB;
                    if (logB>logA)
                        trueT=trueT+1;
                    end
                end
                ROCA=[];
                ROCB=[];
                first=min(min(min(logAA,logBB),logAB),logBA)/TestSize;
                Tresh=(first*3:abs(first)/100:0);
                for j=1:TestSize
                    logA(j)=dhmm_logprob(testDataA(j,:), prior0A, transmat0A, obsmat0A);
                    logB(j)=dhmm_logprob(testDataB(j,:), prior0A, transmat0A, obsmat0A);
                end
                logA=sort(logA,'descend');
                logB=sort(logB,'descend');
                for Tr=Tresh
                    TP_A=sum(find(logA>Tr,1,'last'));
                    FP_A=sum(find(logB>Tr,1,'last'));
                    ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                end
                for j=1:TestSize
                    logA(j)=dhmm_logprob(testDataA(j,:), prior0B, transmat0B, obsmat0B);
                    logB(j)=dhmm_logprob(testDataB(j,:), prior0B, transmat0B, obsmat0B);
                end
                logA=sort(logA,'descend');
                logB=sort(logB,'descend');
                avg_logs(1,:,:)=[mean(logA) mean(logB)];
                for Tr=Tresh
                    TP_B=sum(find(logB>Tr,1,'last'));
                    FP_B=sum(find(logA>Tr,1,'last'));
                    ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                end    
                %h1=figure('name', 'Class A');
                %plot(ROCA(:,2),ROCA(:,3),'LineWidth',2,'DisplayName',['True =  ',num2str(-trapz(ROCA(:,2),ROCA(:,3)))]);                
%                 h2=figure('name', 'Class B');
%                 plot(ROCB(:,2),ROCB(:,3),'LineWidth',2,'DisplayName',['True = ' ,num2str(-trapz(ROCB(:,2),ROCB(:,3)))]);
                AUC(1,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                p=randperm(TestSize);
                trainDataA=trainDataA(p,:);
                p=randperm(TestSize);
                trainDataB=trainDataB(p,:);
                models=1;
                for j=1:TestSize
                    prior1 = normalise(rand(M,1));
                    transmat1 = mk_stochastic(rand(M,M));
                    obsmat1 = mk_stochastic(rand(M,N));
                    [LL2, prior2, transmat2, obsmat2] = dhmm_em(trainDataA(j,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
                    priorA(:,j)=prior2;
                    transmatA(:,:,j)=transmat2;
                    obsmatA(:,:,j)=obsmat2;
                    LL(j)=LL2(size(LL2, 2));
                    prior1 = normalise(rand(M,1));
                    transmat1 = mk_stochastic(rand(M,M));
                    obsmat1 = mk_stochastic(rand(M,N));
                    [LL2, prior2, transmat2, obsmat2] = dhmm_em(trainDataB(j,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
                    priorB(:,j)=prior2;
                    transmatB(:,:,j)=transmat2;
                    obsmatB(:,:,j)=obsmat2;
                    LL(j)=LL2(size(LL2, 2));
                end
                for Trial=[5 10:10:100]%TestSize%[50 100]%[5 10:10:100]
                    for mcfrac=Trial
                        for models=1
                            for seqToModel=1
                                %%
                                clear trainData2A;
                                clear trainData2B;
                                trainData2A=trainDataA(1:Trial,:);
                                trainData2B=trainDataB(1:Trial,:);
                                trueEns=0;
                                %              (Ensemble)  Wk=1
                                W=ones(Trial/seqToModel);
                                Na=Trial/seqToModel;
                                ens_priorA=zeros(M,1);
                                ens_transmatA=zeros(M,M);
                                ens_obsmatA=zeros(M,N);
                                for j=1:Trial/seqToModel
                                    ens_priorA=ens_priorA+priorA(:,j)/Na;
                                    ens_transmatA=ens_transmatA+transmatA(:,:,j)/Na;
                                    ens_obsmatA=ens_obsmatA+obsmatA(:,:,j)/Na;
                                end
                                ens_priorB=zeros(M,1);
                                ens_transmatB=zeros(M,M);
                                ens_obsmatB=zeros(M,N);
                                for j=1:Trial/seqToModel
                                    ens_priorB=ens_priorB+priorB(:,j)/Na;
                                    ens_transmatB=ens_transmatB+transmatB(:,:,j)/Na;
                                    ens_obsmatB=ens_obsmatB+obsmatB(:,:,j)/Na;
                                end
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                    logB(j)=dhmm_logprob(testDataB(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_A=sum(find(logA>Tr,1,'last'));
                                    FP_A=sum(find(logB>Tr,1,'last'));
                                    ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                end
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                    logB(j)=dhmm_logprob(testDataB(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_B=sum(find(logB>Tr,1,'last'));
                                    FP_B=sum(find(logA>Tr,1,'last'));
                                    ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                end  
                                avg_logs(2,:,:)=[mean(logA) mean(logB)];
%                                 figure(h1);
%                                 hold on;
                                %plot(ROCA(:,2),ROCA(:,3),'color','y','LineWidth',2,'DisplayName',['Ensemble =  ',num2str(-trapz(ROCA(:,2),ROCA(:,3)))]);
%                                 figure(h2);
%                                 hold on;
%                                 plot(ROCB(:,2),ROCB(:,3),'color','y','LineWidth',2,'DisplayName',['Ensemble =  ',num2str(-trapz(ROCB(:,2),ROCB(:,3)))]);
                                AUC(2,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                for j=1:TestSize
                                    logA=dhmm_logprob(testDataA(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                    logB=dhmm_logprob(testDataA(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                    dataA(rowcnt+j,6:7)=[logA,logB];
                                    if (logA>logB)
                                        trueEns=trueEns+1;
                                    end
                                    logA=dhmm_logprob(testDataB(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                    logB=dhmm_logprob(testDataB(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                    dataB(rowcnt+j,6:7)=[logA,logB];
                                    if (logB>logA)
                                        trueEns=trueEns+1;
                                    end
                                end
                                prior1A = normalise(rand(M,1));
                                transmat1A = mk_stochastic(rand(M,M));
                                obsmat1A = mk_stochastic(rand(M,N));
                                [LL_R_A, prior_R_A, transmat_R_A, obsmat_R_A] = dhmm_em(trainData2A, prior1, transmat1, obsmat1,'max_iter', 10, 'verbose', 0);
                                prior1B = normalise(rand(M,1));
                                transmat1B = mk_stochastic(rand(M,M));
                                obsmat1B = mk_stochastic(rand(M,N));
                                [LL_R_B, prior_R_B, transmat_R_B, obsmat_R_B] = dhmm_em(trainData2B, prior1, transmat1, obsmat1,'max_iter', 10, 'verbose', 0);
                                trueRand=0;
                                trueRab=0;
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), prior1A, transmat1A, obsmat1A);
                                    logB(j)=dhmm_logprob(testDataB(j,:), prior1A, transmat1A, obsmat1A);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_A=sum(find(logA>Tr,1,'last'));
                                    FP_A=sum(find(logB>Tr,1,'last'));
                                    ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                end
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), prior1B, transmat1B, obsmat1B);
                                    logB(j)=dhmm_logprob(testDataB(j,:), prior1B, transmat1B, obsmat1B);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_B=sum(find(logB>Tr,1,'last'));
                                    FP_B=sum(find(logA>Tr,1,'last'));
                                    ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                end
                                avg_logs(3,:,:)=[mean(logA) mean(logB)];
%                                 figure(h1);
%                                 hold on;
                                %plot(ROCA(:,2),ROCA(:,3),'color','r','LineWidth',2,'DisplayName',['Random =  ',num2str(-trapz(ROCA(:,2),ROCA(:,3)))]);
%                                 figure(h2);
%                                 hold on;
%                                 plot(ROCB(:,2),ROCB(:,3),'color','r','LineWidth',2,'DisplayName',['Random =  ',num2str(-trapz(ROCB(:,2),ROCB(:,3)))]);                                
                                AUC(3,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), prior_R_A, transmat_R_A, obsmat_R_A);
                                    logB(j)=dhmm_logprob(testDataB(j,:), prior_R_A, transmat_R_A, obsmat_R_A);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_A=sum(find(logA>Tr,1,'last'));
                                    FP_A=sum(find(logB>Tr,1,'last'));
                                    ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                end
                                for j=1:TestSize
                                    logA(j)=dhmm_logprob(testDataA(j,:), prior_R_B, transmat_R_B, obsmat_R_B);
                                    logB(j)=dhmm_logprob(testDataB(j,:), prior_R_B, transmat_R_B, obsmat_R_B);
                                end
                                logA=sort(logA,'descend');
                                logB=sort(logB,'descend');
                                for Tr=Tresh
                                    TP_B=sum(find(logB>Tr,1,'last'));
                                    FP_B=sum(find(logA>Tr,1,'last'));
                                    ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                end 
                                avg_logs(4,:,:)=[mean(logA) mean(logB)];
%                                 figure(h1);
%                                 hold on;
                                %plot(ROCA(:,2),ROCA(:,3),'color','green','LineWidth',2,'DisplayName',['Rabiner =  ',num2str(-trapz(ROCA(:,2),ROCA(:,3)))]);
%                                 figure(h2);
%                                 hold on;
%                                 plot(ROCB(:,2),ROCB(:,3),'color','green','LineWidth',2,'DisplayName',['Rabiner =  ',num2str(-trapz(ROCB(:,2),ROCB(:,3)))]);                                
                                AUC(4,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                for j=1:TestSize
                                    logA=dhmm_logprob(testDataA(j,:), prior1A, transmat1A, obsmat1A);
                                    logB=dhmm_logprob(testDataB(j,:), prior1A, transmat1A, obsmat1A);
                                    dataA(rowcnt+j,8:9)=[logA,logB];
                                    if (logA>logB)
                                        trueRand=trueRand+1;
                                    end
                                    logA=dhmm_logprob(testDataA(j,:), prior1B, transmat1B, obsmat1B);
                                    logB=dhmm_logprob(testDataB(j,:), prior1B, transmat1B, obsmat1B);
                                    dataB(rowcnt+j,8:9)=[logA,logB];
                                    if (logB>logA)
                                        trueRand=trueRand+1;
                                    end
                                    logA=dhmm_logprob(testDataA(j,:), prior_R_A, transmat_R_A, obsmat_R_A);
                                    logB=dhmm_logprob(testDataB(j,:), prior_R_A, transmat_R_A, obsmat_R_A);
                                    dataA(rowcnt+j,10:11)=[logA,logB];
                                    if (logA>logB)
                                        trueRab=trueRab+1;
                                    end
                                    logA=dhmm_logprob(testDataA(j,:), prior_R_B, transmat_R_B, obsmat_R_B);
                                    logB=dhmm_logprob(testDataB(j,:), prior_R_B, transmat_R_B, obsmat_R_B);
                                    dataB(rowcnt+j,10:11)=[logA,logB];
                                    if (logB>logA)
                                        trueRab=trueRab+1;
                                    end
                                end
                                %alpha_indx=1;
                                %best=-1000;
                                for alpha=alpha_array
                                    trueAlpha=0;
                                    if(alpha<0)
                                        EPS=eps;
                                    else
                                        EPS=0;
                                    end
                                    ens_priorA=zeros(M,1);
                                    ens_transmatA=zeros(M,M);
                                    ens_obsmatA=zeros(M,N);
                                    for j=1:Trial
                                        if(alpha==0)
                                            ens_priorA=min(ens_priorA,priorA(:,j)+EPS);
                                            ens_transmatA=min(ens_transmatA,transmatA(:,:,j)+EPS);
                                            ens_obsmatA=min(ens_obsmatA,obsmatA(:,:,j)+EPS);
                                        else
                                            ens_priorA=ens_priorA+(priorA(:,j)+EPS).^alpha;
                                            ens_transmatA=ens_transmatA+(transmatA(:,:,j)+EPS).^alpha;
                                            ens_obsmatA=ens_obsmatA+(obsmatA(:,:,j)+EPS).^alpha;
                                        end
                                    end
                                    if(alpha~=0)
                                        ens_priorA=ens_priorA.^(1/alpha);
                                        ens_transmatA=ens_transmatA.^(1/alpha);
                                        ens_obsmatA=ens_obsmatA.^(1/alpha);
                                    end
                                    ens_priorA=(ens_priorA-EPS)./sum(ens_priorA-EPS);
                                    sum_tranA=sum(ens_transmatA-EPS,2);
                                    sum_obsA=sum(ens_obsmatA-EPS,2);
                                    for i=1:M
                                        ens_transmatA(i,:)=(ens_transmatA(i,:)-EPS)./sum_tranA(i);
                                        ens_obsmatA(i,:)=(ens_obsmatA(i,:)-EPS)./sum_obsA(i);
                                    end
                                    ens_priorB=zeros(M,1);
                                    ens_transmatB=zeros(M,M);
                                    ens_obsmatB=zeros(M,N);
                                    for j=1:Trial
                                        if(alpha==0)
                                            ens_priorB=min(ens_priorB,(priorB(:,j)+EPS));
                                            ens_transmatB=min(ens_transmatB,(transmatB(:,:,j)+EPS));
                                            ens_obsmatB=min(ens_obsmatB,(obsmatB(:,:,j)+EPS));
                                        else
                                            ens_priorB=ens_priorB+(priorB(:,j)+EPS).^alpha;
                                            ens_transmatB=ens_transmatB+(transmatB(:,:,j)+EPS).^alpha;
                                            ens_obsmatB=ens_obsmatB+(obsmatB(:,:,j)+EPS).^alpha;
                                        end
                                    end
                                    if(alpha~=0)
                                        ens_priorB=ens_priorB.^(1/alpha);
                                        ens_transmatB=ens_transmatB.^(1/alpha);
                                        ens_obsmatB=ens_obsmatB.^(1/alpha);
                                    end
                                    ens_priorB=(ens_priorB-EPS)./sum(ens_priorB-EPS);
                                    sum_tranB=sum(ens_transmatB-EPS,2);
                                    sum_obsB=sum(ens_obsmatB-EPS,2);
                                    for i=1:M
                                        ens_transmatB(i,:)=(ens_transmatB(i,:)-EPS)./sum_tranB(i);
                                        ens_obsmatB(i,:)=(ens_obsmatB(i,:)-EPS)./sum_obsB(i);
                                    end                                    
                                    Prior_same=zeros(M,1);
                                    Transmat_same=zeros(M,M);
                                    for j=1:Trial
                                        if(alpha==0)
                                            Prior_same=min(Prior_same,(priorA(:,j)+EPS));
                                            Prior_same=min(Prior_same,(priorB(:,j)+EPS));
                                            Transmat_same=min(Transmat_same,(transmatA(:,:,j)+EPS));
                                            Transmat_same=min(Transmat_same,(transmatB(:,:,j)+EPS));
                                        else
                                            Prior_same=Prior_same+(priorA(:,j)+EPS).^alpha;
                                            Prior_same=Prior_same+(priorB(:,j)+EPS).^alpha;
                                            Transmat_same=Transmat_same+(transmatA(:,:,j)+EPS).^alpha;
                                            Transmat_same=Transmat_same+(transmatB(:,:,j)+EPS).^alpha;
                                        end
                                    end
                                    if(alpha~=0)
                                        Prior_same=Prior_same.^(1/alpha);
                                        Transmat_same=Transmat_same.^(1/alpha);
                                    end
                                    Prior_same=(Prior_same-EPS)./sum(Prior_same-EPS);
                                    sum_tran=sum(Transmat_same-EPS,2);
                                    for i=1:M
                                        Transmat_same(i,:)=(Transmat_same(i,:)-EPS)./sum_tran(i);
                                    end
                                    clear tmpB;
                                    clear tmpA;
                                    for ii=1:M
                                        [A,B]=sort(ens_obsmatA(ii,:));
                                        tmp=ens_obsmatA(ii,:);
                                        for i=1:N
                                            tmpA(ii,i)=tmp(B(N-find(B==i)+1));
                                        end
                                    end
                                    for ii=1:M
                                        [A,B]=sort(ens_obsmatB(ii,:));
                                        tmp=ens_obsmatB(ii,:);
                                        for i=1:N
                                            tmpB(ii,i)=tmp(B(N-find(B==i)+1));
                                        end
                                    end
                                    Obsmat_A=(tmpB+ens_obsmatA)/2;
                                    Obsmat_B=(tmpA+ens_obsmatB)/2;
                                    trueAlpha_same=0;                                    
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), Prior_same, Transmat_same, Obsmat_A);
                                        logB(j)=dhmm_logprob(testDataB(j,:), Prior_same, Transmat_same, Obsmat_A);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_A=sum(find(logA>Tr,1,'last'));
                                        FP_A=sum(find(logB>Tr,1,'last'));
                                        ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                    end
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), Prior_same, Transmat_same, Obsmat_B);
                                        logB(j)=dhmm_logprob(testDataB(j,:), Prior_same, Transmat_same, Obsmat_B);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_B=sum(find(logB>Tr,1,'last'));
                                        FP_B=sum(find(logA>Tr,1,'last'));
                                        ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                    end
                                    Percent(alpha==alpha_array,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];                                    
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), Prior_same, Transmat_same, ens_obsmatA);
                                        logB(j)=dhmm_logprob(testDataB(j,:), Prior_same, Transmat_same, ens_obsmatA);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_A=sum(find(logA>Tr,1,'last'));
                                        FP_A=sum(find(logB>Tr,1,'last'));
                                        ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                    end
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), Prior_same, Transmat_same, ens_obsmatB);
                                        logB(j)=dhmm_logprob(testDataB(j,:), Prior_same, Transmat_same, ens_obsmatB);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_B=sum(find(logB>Tr,1,'last'));
                                        FP_B=sum(find(logA>Tr,1,'last'));
                                        ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                    end
                                    Percent_noNeg(alpha==alpha_array,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), ens_priorA, ens_transmatA, Obsmat_A);
                                        logB(j)=dhmm_logprob(testDataB(j,:), ens_priorA, ens_transmatA, Obsmat_A);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_A=sum(find(logA>Tr,1,'last'));
                                        FP_A=sum(find(logB>Tr,1,'last'));
                                        ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                    end
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), ens_priorB, ens_transmatB, Obsmat_B);
                                        logB(j)=dhmm_logprob(testDataB(j,:), ens_priorB, ens_transmatB, Obsmat_B);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_B=sum(find(logB>Tr,1,'last'));
                                        FP_B=sum(find(logA>Tr,1,'last'));
                                        ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                    end
                                    Percent_noSame(alpha==alpha_array,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                        logB(j)=dhmm_logprob(testDataB(j,:), ens_priorA, ens_transmatA, ens_obsmatA);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_A=sum(find(logA>Tr,1,'last'));
                                        FP_A=sum(find(logB>Tr,1,'last'));
                                        ROCA(Tresh==Tr,:)=[Tr FP_A/TestSize TP_A/TestSize];
                                    end
                                    for j=1:TestSize
                                        logA(j)=dhmm_logprob(testDataA(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                        logB(j)=dhmm_logprob(testDataB(j,:), ens_priorB, ens_transmatB, ens_obsmatB);
                                    end
                                    logA=sort(logA,'descend');
                                    logB=sort(logB,'descend');
                                    for Tr=Tresh
                                        TP_B=sum(find(logB>Tr,1,'last'));
                                        FP_B=sum(find(logA>Tr,1,'last'));
                                        ROCB(Tresh==Tr,:)=[Tr FP_B/TestSize TP_B/TestSize];
                                    end
                                    Percent_noSame_noNeg(alpha==alpha_array,:,rpt)=[-trapz(ROCA(:,2),ROCA(:,3)) -trapz(ROCB(:,2),ROCB(:,3))];
                                    %                Report                     %              
                                    fid = fopen('results_4.txt', 'a');
                                    fprintf(fid,'%d\t%d\t%d\t%d\t%d\t%.1f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\t%.3f\n',M,N,T,rpt,Trial,alpha,AUC(1,1,rpt),AUC(1,2,rpt),AUC(2,1,rpt),AUC(2,2,rpt),AUC(3,1,rpt),AUC(3,2,rpt),AUC(4,1,rpt),AUC(4,2,rpt),Percent(alpha==alpha_array,1,rpt),Percent(alpha==alpha_array,2,rpt),Percent_noNeg(alpha==alpha_array,1,rpt),Percent_noNeg(alpha==alpha_array,2,rpt),Percent_noSame(alpha==alpha_array,1,rpt),Percent_noSame(alpha==alpha_array,2,rpt),Percent_noSame_noNeg(alpha==alpha_array,1,rpt),Percent_noSame_noNeg(alpha==alpha_array,2,rpt));
                                    fclose(fid);
                                end                                
                            end
                        end
                    end
                end
                save (['rpt' num2str(rpt) 'M=' num2str(M) 'N=' num2str(N) 'T=' num2str(T)]);
            end
            %figure(h1);
            AUC_avg=(AUC(:,1)+AUC(:,2))/(2*rpt);
            AUC_alpha_avg=(AUC_alpha(:,1)+AUC_alpha(:,2))/(2*rpt);
            AUC_Alph=AUC_alpha_avg;%[alpha_array' AUC_alpha_avg];
%             hold on;
%             xlabel(['true:',num2str(AUC_avg(1)),'   Ensemble:',num2str(AUC_avg(2)),'   Random:',num2str(AUC_avg(3)),'   Rabiner:',num2str(AUC_avg(4)),'   Alpha_1:',num2str(AUC_avg(5)),'   Alpha-neg:',num2str(AUC_Alph)]);

        end
    end
end