close all
clc
clear all
fid = fopen('results.txt', 'w');
fprintf(fid, 'rpt\tState\tObservation\tLenght\talpha\tcount_alpha_all\tPMI_alpha_all\tfrac_alpha_best_all\tTrue_alpha_all\tcount_alpha_SameTr\tPMI_alpha_SameTr\tfrac_alpha_best_SameTr\tTrue_alpha_SameTr\tcount_alpha\tPMI_alpha\tfrac_alpha_best\tTrue_alpha\tcount_alpha_Neg\tPMI_alpha_Neg\tfrac_alpha_best_Neg\tTrue_alpha_Neg\tcount_rab\tPMI_rab\tfrac_rab_best\tTrue_Rab\tcount_ens\tPMI_ens\tfrac_ens_best\tTrue_ens\tcount_med\tPMI_med\tfrac_med_best\tTrue_med\n');
fclose(fid);
M=4;
N=10;
T=10;
K=2;
l=50;
max_itr=5;
alpha_array=[-32 -16 -4 -2 -1 -0.9 -0.8 -0.7 -0.6 -0.5 -0.4 -0.3 -0.2 -0.1 0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 2 4 16 32];
max_loop=30;
for rpt=1:10
    [All_seq,Sequences]=Generate_Sequences(K,l,M,N,T);
    [HMM_priors,HMM_trans,HMM_obs]=Train_HMMs(All_seq,M,N,max_itr);
    frac_rab_best=10;
    frac_ens_best=10;
    frac_med_best=10;
    frac_alpha_best=zeros(1,size(alpha_array,2))+1000;
    frac_alpha_best_same=zeros(1,size(alpha_array,2))+1000;
    frac_alpha_best_same_noNeg=zeros(1,size(alpha_array,2))+1000;
    frac_alpha_best_n=zeros(1,size(alpha_array,2))+1000;
    frac_alpha_best_neg=zeros(1,size(alpha_array,2))+1000;
    frac_alpha=zeros(5,size(alpha_array,2));
    for in_rpt=1:5
        Alls_rab=All_seq;
        Alls_ens=All_seq;
        Alls_alpha=All_seq;
        Alls_rab(:,end)=randi(2,1,uint16(K*l))';
        Alls_ens(:,end)=Alls_rab(:,end);
        Alls_alpha_f=Alls_rab;
        Alls_med=Alls_rab;
        Alls_rab_first=All_seq;
        Alls_ens_first=All_seq;
        Alls_alpha_first=All_seq;
        for i=1:K
            prior_rab(:,i) = normalise(rand(M,1));
            transmat_rab(:,:,i) = mk_stochastic(rand(M,M));
            obsmat_rab(:,:,i) = mk_stochastic(rand(M,N));
            [prior_rab,transmat_rab,obsmat_rab]=Merge_Clusters_rab(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab,max_itr);
            prior_ens(:,i) = HMM_priors(:,i);
            transmat_ens(:,:,i) = HMM_trans(:,:,i);
            obsmat_ens(:,:,i) = HMM_obs(:,:,i);
            [prior_ens,transmat_ens,obsmat_ens]=Merge_Clusters_ens(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens,HMM_priors,HMM_trans,HMM_obs);
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
            prior_med(:,i) = HMM_priors(:,i);
            transmat_med(:,:,i) = HMM_trans(:,:,i);
            obsmat_med(:,:,i) = HMM_obs(:,:,i);
            [prior_med,transmat_med,obsmat_med]=Compute_center(Alls_med,i,prior_med,transmat_med,obsmat_med,HMM_priors,HMM_trans,HMM_obs);
        end
        prior_med_first=prior_med;
        transmat_med_first=transmat_med;
        obsmat_med_first=obsmat_med;
        %      Rabiner     %%
        %********       Mean        **********%
        PMI_first_rab=-100;
        PMI_second_rab=-10;
        count_rab=0;
        while(PMI_second_rab>PMI_first_rab && count_rab<max_loop)
            count_rab=count_rab+1;
            Alls_rab_first=Alls_rab;
            for i=1:K*l
                [L1_rab L2_rab]=Measure_Matrix(prior_rab,transmat_rab,obsmat_rab,Alls_rab,Alls_rab(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                [L_S,L_KLS,L_BP]=compute_distance(L1_rab,L2_rab);
                Measure=L_S;
                [~,c]=find(Measure==max(Measure));
                Alls_rab(i,T+1)=c(1);
            end
            for i=1:K
                [prior_rab,transmat_rab,obsmat_rab]=Merge_Clusters_rab(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab,max_itr);
                dist_in(i)=Inter_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
                dist_out(i)=Outer_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
            end
            PMI_first_rab=PMI_second_rab;
            PMI_second_rab=Computer_PMI(Alls_rab,prior_rab,transmat_rab,obsmat_rab);
        end
        Alls_rab=Alls_rab_first;
        for i=1:K
            dist_in_rab(in_rpt,i)=Inter_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
            dist_out_rab(in_rpt,i)=Outer_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
        end
        frac_rab(in_rpt)=sum(dist_in_rab(in_rpt,:))/sum(dist_out_rab(in_rpt,:));
        if((in_rpt>1 && frac_rab(in_rpt)<frac_rab_best) && ~isnan(frac_rab(in_rpt))|| in_rpt==1)
            frac_rab_best=frac_rab(in_rpt);
            if(isnan(frac_rab_best))
                frac_rab_best=10;
            end
            X=[Alls_rab(:,end) All_seq(:,end)];
            for i=1:K
                cluster_rab=X(X(:,1)==i,:);
                for j=1:K
                    cnt_rab(i,j)=sum(cluster_rab(:,2)==j);
                    percent_rab(i,j)=cnt_rab(i,j)/l;
                end
            end
            if (K==2)
                sum1=percent_rab(1,1)+percent_rab(2,2);
                sum2=percent_rab(1,2)+percent_rab(2,1);
                if(sum1>sum2)
                    True_Rab(rpt)=sum1/2;
                else
                    True_Rab(rpt)=sum2/2;
                end
            end
        end
        %%      Ensemble        %%
        PMI_first_ens=-100;
        PMI_second_ens=-10;
        count_ens=0;
        while(PMI_second_ens>PMI_first_ens && count_ens<max_loop)
            count_ens=count_ens+1;
            Alls_ens_first=Alls_ens;
            for i=1:K*l
                [L1_ens L2_ens]=Measure_Matrix(prior_ens,transmat_ens,obsmat_ens,Alls_ens,Alls_ens(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                [L_S,L_KLS,L_BP]=compute_distance(L1_ens,L2_ens);
                Measure=L_S;
                [~,c]=find(Measure==max(Measure));
                Alls_ens(i,T+1)=c(1);            
            end
            for i=1:K
                [prior_ens,transmat_ens,obsmat_ens]=Merge_Clusters_ens(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens,HMM_priors,HMM_trans,HMM_obs);
            end
            PMI_first_ens=PMI_second_ens;
            PMI_second_ens=Computer_PMI(Alls_ens,prior_ens,transmat_ens,obsmat_ens);
        end
        Alls_ens=Alls_ens_first;
        for i=1:K
            dist_in_ens(in_rpt,i)=Inter_Cluster_Dist(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens);
            dist_out_ens(in_rpt,i)=Outer_Cluster_Dist(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens);
        end
        frac_ens(in_rpt)=sum(dist_in_ens(in_rpt,:))/sum(dist_out_ens(in_rpt,:));
        if((in_rpt>1 && frac_ens(in_rpt)<frac_ens_best && ~isnan(frac_ens(in_rpt)))|| in_rpt==1)
            frac_ens_best=frac_ens(in_rpt);
            if(isnan(frac_ens_best))
                frac_ens_best=10;
            end
            Y=[Alls_ens(:,end) All_seq(:,end)];
            for i=1:K
                cluster_ens=Y(Y(:,1)==i,:);
                for j=1:K
                    cnt_ens(i,j)=sum(cluster_ens(:,2)==j);
                    percent_ens(i,j)=cnt_ens(i,j)/l;
                end
            end
            if (K==2)
                sum1=percent_ens(1,1)+percent_ens(2,2);
                sum2=percent_ens(1,2)+percent_ens(2,1);
                if(sum1>sum2)
                    True_Ens(rpt)=sum1/2;
                else
                    True_Ens(rpt)=sum2/2;
                end
            end
        end
        %%      Alpha           %%
        count_alpha_n=zeros(size(alpha_array,2),1);
        Alls_alpha=All_seq;
        Alls_alpha_f=Alls_rab;
        Alls_alpha_first=All_seq;
        for i=1:K
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
        end
        for alpha=alpha_array
            Alls_alpha(:,end)=Alls_alpha_f(:,end);
            for i=1:K
                prior_alpha(:,i)=prior_alpha_first(:,i);
                transmat_alpha(:,:,i)=transmat_alpha_first(:,:,i);
                obsmat_alpha(:,:,i)=obsmat_alpha_first(:,:,i);
                [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
            end
            Alls_alpha_first=All_seq;
            count_alpha_n(alpha==alpha_array)=0;
            frac_alpha_first=100;
            PMI_first=-100;
            PMI_second=-10;
            while(PMI_second>PMI_first && count_alpha_n(alpha==alpha_array)<max_loop)            
                count_alpha_n(alpha==alpha_array)=count_alpha_n(alpha==alpha_array)+1;
                Alls_alpha_first=Alls_alpha;
                for i=1:K*l
                    [L1_alpha L2_alpha]=Measure_Matrix(prior_alpha,transmat_alpha,obsmat_alpha,Alls_alpha,Alls_alpha(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                    [L_S,L_KLS,L_BP]=compute_distance(L1_alpha,L2_alpha);
                    Measure=L_S;
                    [~,c]=find(Measure==max(Measure));
                    if(size(c,2)>0)
                        Alls_alpha(i,T+1)=c(1);
                    end                    
                end
                for i=1:K
                    [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
                end                
                PMI_first=PMI_second;
                PMI_n(alpha==alpha_array,count_alpha_n(alpha==alpha_array))=Computer_PMI(Alls_alpha,prior_alpha,transmat_alpha,obsmat_alpha);
                PMI_second=PMI_n(alpha==alpha_array,count_alpha_n(alpha==alpha_array));
            end
            Alls_alpha=Alls_alpha_first;
            for i=1:K
                dist_in_alpha(alpha==alpha_array,in_rpt,i)=Inter_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
                dist_out_alpha(alpha==alpha_array,in_rpt,i)=Outer_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
            end
            frac_alpha_n(in_rpt,alpha==alpha_array)=sum(dist_in_alpha(alpha==alpha_array,in_rpt,:))/sum(dist_out_alpha(alpha==alpha_array,in_rpt,:));
            if((in_rpt>1 && frac_alpha_n(in_rpt,alpha==alpha_array)<frac_alpha_best_n(alpha==alpha_array) && ~isnan(frac_alpha_n(in_rpt,alpha==alpha_array)))|| in_rpt==1)
                frac_alpha_best_n(alpha==alpha_array)=frac_alpha_n(in_rpt,alpha==alpha_array);
                if(isnan(frac_alpha_best_n(alpha==alpha_array)))
                    frac_alpha_best_n(alpha==alpha_array)=1000;
                end
                Z=[Alls_alpha(:,end) All_seq(:,end)];
                for i=1:K
                    cluster_alpha=Z(Z(:,1)==i,:);
                    for j=1:K
                        cnt_alpha(i,j)=sum(cluster_alpha(:,2)==j);
                        percent_alpha(i,j)=cnt_alpha(i,j)/l;
                    end
                end
                if (K==2)
                    sum1=percent_alpha(1,1)+percent_alpha(2,2);
                    sum2=percent_alpha(1,2)+percent_alpha(2,1);
                    if(sum1>sum2)
                        True_alpha_n(rpt,alpha==alpha_array)=sum1/2;
                    else
                        True_alpha_n(rpt,alpha==alpha_array)=sum2/2;
                    end
                end
            end
        end
        %******** Alpha with Neg   *************%
        Alls_alpha=All_seq;
        Alls_alpha_f=Alls_rab;
        Alls_alpha_first=All_seq;
        for i=1:K
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
        end
        for alpha=alpha_array
            Alls_alpha(:,end)=Alls_alpha_f(:,end);
            for i=1:K
                prior_alpha(:,i)=prior_alpha_first(:,i);
                transmat_alpha(:,:,i)=transmat_alpha_first(:,:,i);
                obsmat_alpha(:,:,i)=obsmat_alpha_first(:,:,i);
                [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
            end
            Alls_alpha_first=All_seq;
            count_alpha_neg(alpha==alpha_array)=0;
            frac_alpha_first=100;
            PMI_first=-100;
            PMI_second=-10;
            while(PMI_second>PMI_first && count_alpha_neg(alpha==alpha_array)<max_loop)            
                count_alpha_neg(alpha==alpha_array)=count_alpha_neg(alpha==alpha_array)+1;
                Alls_alpha_first=Alls_alpha;
                for i=1:K*l
                    [L1_alpha L2_alpha]=Measure_Matrix(prior_alpha,transmat_alpha,obsmat_alpha,Alls_alpha,Alls_alpha(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                    [L_S,L_KLS,L_BP]=compute_distance(L1_alpha,L2_alpha);
                    Measure=L_S;
                    [~,c]=find(Measure==max(Measure));
                    if(size(c,2)>0)
                        Alls_alpha(i,T+1)=c(1);
                    end                    
                end
                for i=1:K
                    [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
                end
                obsmat_alpha=Negative_Obs_alpha(obsmat_alpha,alpha);
                PMI_first=PMI_second;
                PMI_neg(alpha==alpha_array,count_alpha_neg(alpha==alpha_array))=Computer_PMI(Alls_alpha,prior_alpha,transmat_alpha,obsmat_alpha);
                PMI_second=PMI_neg(alpha==alpha_array,count_alpha_neg(alpha==alpha_array));
            end
            Alls_alpha=Alls_alpha_first;
            for i=1:K
                dist_in_alpha(alpha==alpha_array,in_rpt,i)=Inter_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
                dist_out_alpha(alpha==alpha_array,in_rpt,i)=Outer_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
            end
            frac_alpha_neg(in_rpt,alpha==alpha_array)=sum(dist_in_alpha(alpha==alpha_array,in_rpt,:))/sum(dist_out_alpha(alpha==alpha_array,in_rpt,:));
            if((in_rpt>1 && frac_alpha_neg(in_rpt,alpha==alpha_array)<frac_alpha_best_neg(alpha==alpha_array) && ~isnan(frac_alpha_neg(in_rpt,alpha==alpha_array)))|| in_rpt==1)
                frac_alpha_best_neg(alpha==alpha_array)=frac_alpha_neg(in_rpt,alpha==alpha_array);
                if(isnan(frac_alpha_best_neg(alpha==alpha_array)))
                    frac_alpha_best_neg(alpha==alpha_array)=1000;
                end
                Z=[Alls_alpha(:,end) All_seq(:,end)];
                for i=1:K
                    cluster_alpha=Z(Z(:,1)==i,:);
                    for j=1:K
                        cnt_alpha(i,j)=sum(cluster_alpha(:,2)==j);
                        percent_alpha(i,j)=cnt_alpha(i,j)/l;
                    end
                end
                if (K==2)
                    sum1=percent_alpha(1,1)+percent_alpha(2,2);
                    sum2=percent_alpha(1,2)+percent_alpha(2,1);
                    if(sum1>sum2)
                        True_alpha_neg(rpt,alpha==alpha_array)=sum1/2;
                    else
                        True_alpha_neg(rpt,alpha==alpha_array)=sum2/2;
                    end
                end
            end
        end
        %********       Medoid        **********%
        count_med=0;
        PMI_first_med=-100;
        PMI_second_med=-10;
        Alls_med=Alls_alpha_f;
        Alls_med_first=All_seq;
        while(PMI_second_med>PMI_first_med && count_med<max_loop)
            count_med=count_med+1;
            Alls_med_first=Alls_med;
            for i=1:K*l
                [L1_med L2_med]=Measure_Matrix(prior_med,transmat_med,obsmat_med,Alls_med,Alls_med(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                [L_S,L_KLS,L_BP]=compute_distance(L1_med,L2_med);
                Measure=L_S;
                [~,c]=find(Measure==max(Measure));
                Alls_med(i,T+1)=c(1);                
            end
            for i=1:K
                [prior_med,transmat_med,obsmat_med]=Compute_center(Alls_med,i,prior_med,transmat_med,obsmat_med,HMM_priors,HMM_trans,HMM_obs);
                dist_in(i)=Inter_Cluster_Dist(Alls_med,i,prior_med,transmat_med,obsmat_med);
                dist_out(i)=Outer_Cluster_Dist(Alls_med,i,prior_med,transmat_med,obsmat_med);
            end
            PMI_first_med=PMI_second_med;
            PMI_second_med=Computer_PMI(Alls_med,prior_med,transmat_med,obsmat_med);
        end
        Alls_med=Alls_med_first;
        for i=1:K
            dist_in_med(in_rpt,i)=Inter_Cluster_Dist(Alls_med,i,prior_med,transmat_med,obsmat_med);
            dist_out_med(in_rpt,i)=Outer_Cluster_Dist(Alls_med,i,prior_med,transmat_med,obsmat_med);
        end
        frac_med(in_rpt)=sum(dist_in_med(in_rpt,:))/sum(dist_out_med(in_rpt,:));
        if((in_rpt>1 && frac_med(in_rpt)<frac_med_best) && ~isnan(frac_med(in_rpt))|| in_rpt==1)
            frac_med_best=frac_med(in_rpt);
            if(isnan(frac_med_best))
                frac_med_best=10;
            end
            X=[Alls_med(:,end) All_seq(:,end)];
            for i=1:K
                cluster_med=X(X(:,1)==i,:);
                for j=1:K
                    cnt_med(i,j)=sum(cluster_med(:,2)==j);
                    percent_med(i,j)=cnt_med(i,j)/l;
                end
            end
            if (K==2)
                sum1=percent_med(1,1)+percent_med(2,2);
                sum2=percent_med(1,2)+percent_med(2,1);
                if(sum1>sum2)
                    True_med(rpt)=sum1/2;
                else
                    True_med(rpt)=sum2/2;
                end
            end
        end 
    end
    for alpha=alpha_array
        fid = fopen('results2.txt', 'a');
        %fprintf(fid, 'rpt\talpha\tcount_alpha\tPMI_alpha\tfrac_alpha_best\tTrue_alpha\tcount_rab\tPMI_rab\tfrac_rab_best\tTrue_Rab\tcount_ens\tPMI_ens\tfrac_ens_best\tTrue_ens\n');
        fprintf(fid, '%d\t%d\t%d\t%d\t%.1f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\t%d\t%.3f\t%.3f\t%.3f\n',rpt,M,N,T,alpha,count_alpha(alpha==alpha_array),PMI(alpha==alpha_array,max(1,count_alpha(alpha==alpha_array)-1)),frac_alpha_best_same(alpha==alpha_array),True_alpha_same(rpt,alpha==alpha_array),count_alpha_noNeg(alpha==alpha_array),PMI_noNeg(alpha==alpha_array,max(1,count_alpha_noNeg(alpha==alpha_array)-1)),frac_alpha_best_same_noNeg(alpha==alpha_array),True_alpha_same_noNeg(rpt,alpha==alpha_array),count_alpha_n(alpha==alpha_array),PMI_n(alpha==alpha_array,max(1,count_alpha_n(alpha==alpha_array)-1)),frac_alpha_best_n(alpha==alpha_array),True_alpha_n(rpt,alpha==alpha_array),count_alpha_neg(alpha==alpha_array),PMI_neg(alpha==alpha_array,max(1,count_alpha_neg(alpha==alpha_array)-1)),frac_alpha_best_neg(alpha==alpha_array),True_alpha_neg(rpt,alpha==alpha_array),count_rab,PMI_first_rab,frac_rab_best,True_Rab(rpt),count_ens,PMI_first_ens,frac_ens_best,True_Ens(rpt),count_med,PMI_first_med,frac_med_best,True_med(rpt));
        fclose(fid);
    end
     save (['rpt-T=10' num2str(rpt)]);
end
Rabiner=mean(True_Rab,2);
Ensemble=mean(True_Ens,2);
Alpha_normal=mean(True_alpha_n,1);
Alpha_justNeg=mean(True_alpha_neg,1);
Medoid=mean(True_med,2);
Y=[Alpha_same' Alpha_same_noNeg' Alpha_normal' Alpha_justNeg' repmat([Rabiner Ensemble Medoid],size(alpha_array,2),1)];
figure('name','Percent');
X = 1:1:size(alpha_array,2);
alpha_str=num2str(alpha_array');
plot(X,Y,'LineWidth', 2);
set(gca,'XTick',X)
set(gca,'XTickLabel',alpha_str);
legend('Alpha_same','Alpha_same_noNeg','Alpha_normal','Alpha_justNeg','Rabiner','Ensemble','Medoid');
