function [All_seq,Sequences]= Generate_Sequences(K,l,M,N,T)
All_seq=[];
True_ratio=0.05;
for k=1:K
    prior(:,k) = normalise(rand(M,1));
    transmat(:,:,k) = mk_stochastic(rand(M,M));
    obsmat(:,:,k) = mk_stochastic(rand(M,N));
    Sequences(:,:,k)= dhmm_sample(prior, transmat, obsmat, l, T);
end
log11=dhmm_logprob(Sequences(:,:,1), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
log21=dhmm_logprob(Sequences(:,:,2), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
log22=dhmm_logprob(Sequences(:,:,2), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
log12=dhmm_logprob(Sequences(:,:,1), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
cnt=0;
while((log11-log21)/abs(log11)<True_ratio || (log22-log12)/abs(log22)<True_ratio)
    cnt=cnt+1;
    prior(:,2) = normalise(rand(M,1));
    transmat(:,:,2) = mk_stochastic(rand(M,M));
    obsmat(:,:,2) = mk_stochastic(rand(M,N));
    Sequences(:,:,2)= dhmm_sample(prior, transmat, obsmat, l, T);
    log11=dhmm_logprob(Sequences(:,:,1), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
    log21=dhmm_logprob(Sequences(:,:,2), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
    log22=dhmm_logprob(Sequences(:,:,2), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
    log12=dhmm_logprob(Sequences(:,:,1), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
    if (cnt>50 && ((log11-log21)/abs(log11)<True_ratio || (log22-log12)/abs(log22)<True_ratio) )
        prior(:,1) = normalise(rand(M,1));
        transmat(:,:,1) = mk_stochastic(rand(M,M));
        obsmat(:,:,1) = mk_stochastic(rand(M,N));
        Sequences(:,:,1)= dhmm_sample(prior, transmat, obsmat, l, T);
        log11=dhmm_logprob(Sequences(:,:,1), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
        log21=dhmm_logprob(Sequences(:,:,2), prior(:,1), transmat(:,:,1), obsmat(:,:,1));
        log22=dhmm_logprob(Sequences(:,:,2), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
        log12=dhmm_logprob(Sequences(:,:,1), prior(:,2), transmat(:,:,2), obsmat(:,:,2));
        cnt=0;
    end
end
for i=1:K
    All_seq=[All_seq ; Sequences(:,:,i) repmat(i,l,1)];
end
p=randperm(l*K);
All_seq=All_seq(p,:);
end