function [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,c,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha)
[Seq_c ~]=find(Alls_alpha(:,size(Alls_alpha,2))==c);
if(size(Seq_c,1)>1)
    M=size(HMM_obs,1);
    N=size(HMM_obs,2);
    if(alpha==0)
        prior2=ones(M,1);
        trans2=ones(M,M);
        obs2=ones(M,N);
        for i=1:size(Seq_c,1)
            prior2=min(prior2,HMM_priors(:,Seq_c(i)));
            trans2=min(trans2,HMM_trans(:,:,Seq_c(i)));
            obs2=min(obs2,HMM_obs(:,:,Seq_c(i)));
        end
    else
        prior2=zeros(M,1);
        trans2=zeros(M,M);
        obs2=zeros(M,N);
        for i=1:size(Seq_c,1)
            prior2=prior2+HMM_priors(:,Seq_c(i)).^alpha;
            trans2=trans2+HMM_trans(:,:,Seq_c(i)).^alpha;
            obs2=obs2+HMM_obs(:,:,Seq_c(i)).^alpha;
        end
        prior2=prior2.^(1/alpha);
        trans2=trans2.^(1/alpha);
        obs2=obs2.^(1/alpha);
    end
    if(sum(prior2)==0)
        prior2=ones(M,1)/M;
    else
        prior2=prior2/sum(prior2);
    end
    for j=1:M
        if(sum(trans2(j,:))==0)
            trans2(j,:)=ones(1,M)/M;
        else
            trans2(j,:)=trans2(j,:)/sum(trans2(j,:));
        end
        if(sum(obs2(j,:))==0)
            obs2(j,:)=ones(1,N)/N;
        else
            obs2(j,:)=obs2(j,:)/sum(obs2(j,:));
        end        
    end
    prior_alpha(:,c)=prior2;
    transmat_alpha(:,:,c)=trans2;
    obsmat_alpha(:,:,c)=obs2;
end
end