function [prior_alpha,transmat_alpha]=Merge_TranPrior_alpha(prior_alpha,transmat_alpha,HMM_priors,HMM_trans,alpha)
num=size(HMM_priors,2);
M=size(HMM_priors,1);
K=size(prior_alpha,2);
if(alpha==0)
    prior2=ones(M,1);
    trans2=ones(M,M);
    for i=1:num
        prior2=min(prior2,HMM_priors(:,i));
        trans2=min(trans2,HMM_trans(:,:,i));
    end
else
    prior2=zeros(M,1);
    trans2=zeros(M,M);
    for i=1:num
        prior2=prior2+HMM_priors(:,i).^alpha;
        trans2=trans2+HMM_trans(:,:,i).^alpha;
    end
    prior2=prior2.^(1/alpha);
    trans2=trans2.^(1/alpha);
end
if(sum(prior2)==0)
    prior2=ones(M,1)/M;
else
    prior2=prior2/sum(prior2);
end
for j=1:M
    if(sum(trans2(j,:))==0)
        trans2(j,:)=ones(1,M)/M;
    else
        trans2(j,:)=trans2(j,:)/sum(trans2(j,:));
    end
end
for c=1:K
    prior_alpha(:,c)=prior2;
    transmat_alpha(:,:,c)=trans2;
end
end