function [HMM_priors,HMM_trans,HMM_obs]=Train_HMMs(All_seq,M,N,max_itr)
All=All_seq(:,1:end-1);
for i=1:size(All_seq,1)
    prior1 = normalise(rand(M,1));
    transmat1 = mk_stochastic(rand(M,M));
    obsmat1 = mk_stochastic(rand(M,N));
    [~, prior2, trans2, obs2] = dhmm_em(All(i,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
    prior2(prior2==0)=eps;
    trans2(trans2==0)=eps;
    obs2(obs2==0)=eps;
    prior2=prior2/sum(prior2);
    for j=1:M
        trans2(j,:)=trans2(j,:)/sum(trans2(j,:));
        obs2(j,:)=obs2(j,:)/sum(obs2(j,:));
    end
    HMM_priors(:,i)=prior2;
    HMM_trans(:,:,i)=trans2;
    HMM_obs(:,:,i)=obs2;
end
end