close all
clc
clear all
load Gunx
max_itr = 5;
M=4;
N=8;
T=50;
%T=75;
%T=150;
K=2;
max_loop=25;
%alpha_array = [-64 -32 -16 -8 -4 -3 -2 -1.7 -1.5 -1.4 -1.3 -1.2 -1.1 -1 -0.9 -0.8 -0.7 -0.6 -0.5 -0.4 -0.3 -0.2 -0.1 0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1 1.1 1.2 1.3 1.4 1.5 1.7 2 3 4 8 16 32 64];
alpha_array = 0.1;%[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1];% 1.1 1.2 1.3 1.4 1.5 1.7 2 3 4 8 16 32 64];
for rpt=1:1
    clear datat;
    for i=2:3:150
        datat(:,(i+1)/3)=(Gunx(:,i)+Gunx(:,i+1)+Gunx(:,i+2))/3;
    end
    labels_data=Gunx(:,1);
    A=randperm(size(Gunx,1));
    data=datat(A',:);
    labels_data=labels_data(A');
    train_data=data(1:end,:);
    train_labels=labels_data(1:end,:);
    test_data=data(51:end,:);
    test_labels=labels_data(51:end,:);
    sz=size(train_data);
    train_data=quantize(train_data,'levels',N);
    %           base HMMs
    for j=1:size(train_data,1)
        prior1 = normalise(rand(M,1));
        transmat1 = mk_stochastic(rand(M,M));
        obsmat1 = mk_stochastic(rand(M,N));
        [LL2, prior2, transmat2, obsmat2] = dhmm_em(train_data(j,:), prior1, transmat1, obsmat1,'max_iter', max_itr, 'verbose', 0);
        HMM_priors(:,j)=prior2;
        HMM_trans(:,:,j)=transmat2;
        HMM_obs(:,:,j)=obsmat2;
        LL(j)=LL2(size(LL2, 2));
        for i=1:M
           if(HMM_priors(i,j)==0)
               HMM_priors(i,j)=eps;
           end
           for ii=1:M
               if(HMM_trans(i,ii,j)==0)
                   HMM_trans(i,ii,j)=eps;
               end
           end
           for ii=1:N
               if(HMM_obs(i,ii,j)==0)
                   HMM_obs(i,ii,j)=eps;
               end
           end
        end
    end
    frac_rab_best=10;
    frac_ens_best=10;
    frac_med_best=10;
    frac_alpha=zeros(5,size(alpha_array,2));
    for in_rpt=1:5
        train_data(:,end)=train_labels;
        Alls_rab=train_data;
        Alls_ens=train_data;
        Alls_alpha=train_data;
        Alls_rab(:,end)=randi(2,1,uint16(sz(1)))';
        Alls_ens(:,end)=Alls_rab(:,end);
        Alls_alpha_f=Alls_rab;
        Alls_med=Alls_rab;
        Alls_rab_first=train_data;
        Alls_ens_first=train_data;
        Alls_alpha_first=train_data;
        for i=1:K
            prior_rab(:,i) = normalise(rand(M,1));
            transmat_rab(:,:,i) = mk_stochastic(rand(M,M));
            obsmat_rab(:,:,i) = mk_stochastic(rand(M,N));
            [prior_rab,transmat_rab,obsmat_rab]=Merge_Clusters_rab(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab,max_itr);
            prior_ens(:,i) = HMM_priors(:,i);
            transmat_ens(:,:,i) = HMM_trans(:,:,i);
            obsmat_ens(:,:,i) = HMM_obs(:,:,i);
            [prior_ens,transmat_ens,obsmat_ens]=Merge_Clusters_ens(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens,HMM_priors,HMM_trans,HMM_obs);
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
            prior_med(:,i) = HMM_priors(:,i);
            transmat_med(:,:,i) = HMM_trans(:,:,i);
            obsmat_med(:,:,i) = HMM_obs(:,:,i);
        end
        prior_med_first=prior_med;
        transmat_med_first=transmat_med;
        obsmat_med_first=obsmat_med;
        %           Rabiner
        PMI_first_rab=-100;
        PMI_second_rab=-10;
        count_rab=0;
        while(PMI_second_rab>PMI_first_rab && count_rab<max_loop)
            count_rab=count_rab+1;
            Alls_rab_first=Alls_rab;
            for i=1:sz(1)
                [L1_rab L2_rab]=Measure_Matrix(prior_rab,transmat_rab,obsmat_rab,Alls_rab,Alls_rab(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                [L_S,L_KLS,L_BP]=compute_distance(L1_rab,L2_rab);
                Measure=L_S;
                [~,c]=find(Measure==max(Measure));
                Alls_rab(i,T+1)=c(1);
            end
            for i=1:K
                [prior_rab,transmat_rab,obsmat_rab]=Merge_Clusters_rab(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab,max_itr);
                dist_in(i)=Inter_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
                dist_out(i)=Outer_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
            end
            PMI_first_rab=PMI_second_rab;
            PMI_second_rab=Computer_PMI(Alls_rab,prior_rab,transmat_rab,obsmat_rab);
        end        
        Alls_rab=Alls_rab_first;
        for i=1:K
            dist_in_rab(in_rpt,i)=Inter_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
            dist_out_rab(in_rpt,i)=Outer_Cluster_Dist(Alls_rab,i,prior_rab,transmat_rab,obsmat_rab);
        end
        frac_rab(in_rpt)=sum(dist_in_rab(in_rpt,:))/sum(dist_out_rab(in_rpt,:));
        if((in_rpt>1 && frac_rab(in_rpt)<frac_rab_best) && ~isnan(frac_rab(in_rpt))|| in_rpt==1)
            frac_rab_best=frac_rab(in_rpt);
            if(isnan(frac_rab_best))
                frac_rab_best=10;
            end
            X=[Alls_rab(:,end) train_data(:,end)];
            for i=1:K
                cluster_rab=X(X(:,1)==i,:);
                for j=1:K
                    cnt_rab(i,j)=sum(cluster_rab(:,2)==j);
                    percent_rab(i,j)=cnt_rab(i,j);%/sum(train_labels==);
                end
            end
            if (K==2)
                sum1=percent_rab(1,1)+percent_rab(2,2);
                sum2=percent_rab(1,2)+percent_rab(2,1);
                if(sum1>sum2)
                    True_Rab(rpt)=sum1/sz(1);
                else
                    True_Rab(rpt)=sum2/sz(1);
                end
            end
            iter_rab(rpt)=count_rab;
            PMI_rab(rpt)=PMI_first_rab;
        end
        frac_rab(rpt)=frac_rab_best;
        %              (Ensemble)  Wk=1
        PMI_first_ens=-100;
        PMI_second_ens=-10;
        count_ens=0;
        while(PMI_second_ens>PMI_first_ens && count_ens<max_loop)
            count_ens=count_ens+1;
            Alls_ens_first=Alls_ens;
            for i=1:sz(1)
                [L1_ens L2_ens]=Measure_Matrix(prior_ens,transmat_ens,obsmat_ens,Alls_ens,Alls_ens(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                [L_S,L_KLS,L_BP]=compute_distance(L1_ens,L2_ens);
                Measure=L_S;
                [~,c]=find(Measure==max(Measure));
                Alls_ens(i,T+1)=c(1);
            end
            for i=1:K
                [prior_ens,transmat_ens,obsmat_ens]=Merge_Clusters_ens(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens,HMM_priors,HMM_trans,HMM_obs);
            end
            PMI_first_ens=PMI_second_ens;
            PMI_second_ens=Computer_PMI(Alls_ens,prior_ens,transmat_ens,obsmat_ens);
        end
        Alls_ens=Alls_ens_first;
        for i=1:K
            dist_in_ens(in_rpt,i)=Inter_Cluster_Dist(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens);
            dist_out_ens(in_rpt,i)=Outer_Cluster_Dist(Alls_ens,i,prior_ens,transmat_ens,obsmat_ens);
        end
        frac_ens(in_rpt)=sum(dist_in_ens(in_rpt,:))/sum(dist_out_ens(in_rpt,:));
        if((in_rpt>1 && frac_ens(in_rpt)<frac_ens_best && ~isnan(frac_ens(in_rpt)))|| in_rpt==1)
            frac_ens_best=frac_ens(in_rpt);
            if(isnan(frac_ens_best))
                frac_ens_best=10;
            end
            Y=[Alls_ens(:,end) train_data(:,end)];
            for i=1:K
                cluster_ens=Y(Y(:,1)==i,:);
                for j=1:K
                    cnt_ens(i,j)=sum(cluster_ens(:,2)==j);
                    percent_ens(i,j)=cnt_ens(i,j);
                end
            end
            if (K==2)
                sum1=percent_ens(1,1)+percent_ens(2,2);
                sum2=percent_ens(1,2)+percent_ens(2,1);
                if(sum1>sum2)
                    True_Ens(rpt)=sum1/sz(1);
                else
                    True_Ens(rpt)=sum2/sz(1);
                end
            end
            iter_ens(rpt)=count_ens;
            PMI_ens(rpt)=PMI_first_ens;
        end
        frac_ens(rpt)=frac_ens_best;
        %                   alpha        
        count_alpha_n=zeros(size(alpha_array,2),1);
        Alls_alpha=train_data;
        Alls_alpha_f=Alls_rab;
        Alls_alpha_first=train_data;
        for i=1:K
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
        end
        for alpha=alpha_array
            Alls_alpha(:,end)=Alls_alpha_f(:,end);
            for i=1:K
                prior_alpha(:,i)=prior_alpha_first(:,i);
                transmat_alpha(:,:,i)=transmat_alpha_first(:,:,i);
                obsmat_alpha(:,:,i)=obsmat_alpha_first(:,:,i);
                [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
            end
            Alls_alpha_first=train_data;
            count_alpha_n(alpha==alpha_array)=0;
            frac_alpha_first=100;
            PMI_first=-100;
            PMI_second=-10;
            while(PMI_second>PMI_first && count_alpha_n(alpha==alpha_array)<max_loop)
                count_alpha_n(alpha==alpha_array)=count_alpha_n(alpha==alpha_array)+1;
                Alls_alpha_first=Alls_alpha;
                for i=1:sz(1)
                    [L1_alpha L2_alpha]=Measure_Matrix(prior_alpha,transmat_alpha,obsmat_alpha,Alls_alpha,Alls_alpha(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                    [L_S,L_KLS,L_BP]=compute_distance(L1_alpha,L2_alpha);
                    Measure=L_S;
                    [~,c]=find(Measure==max(Measure));
                    if(size(c,2)>0)
                        Alls_alpha(i,T+1)=c(1);
                    end
                end
                for i=1:K
                    [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
                end
                PMI_first=PMI_second;
                PMI_n(alpha==alpha_array,count_alpha_n(alpha==alpha_array))=Computer_PMI(Alls_alpha,prior_alpha,transmat_alpha,obsmat_alpha);
                PMI_second=PMI_n(alpha==alpha_array,count_alpha_n(alpha==alpha_array));
            end
            Alls_alpha=Alls_alpha_first;
            for i=1:K
                dist_in_alpha(alpha==alpha_array,in_rpt,i)=Inter_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
                dist_out_alpha(alpha==alpha_array,in_rpt,i)=Outer_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
            end
            frac_alpha_n(in_rpt,alpha==alpha_array)=sum(dist_in_alpha(alpha==alpha_array,in_rpt,:))/sum(dist_out_alpha(alpha==alpha_array,in_rpt,:));
            if((in_rpt>1 && frac_alpha_n(in_rpt,alpha==alpha_array)<frac_alpha_best_n(alpha==alpha_array) && ~isnan(frac_alpha_n(in_rpt,alpha==alpha_array)))|| in_rpt==1)
                frac_alpha_best_n(alpha==alpha_array)=frac_alpha_n(in_rpt,alpha==alpha_array);
                if(isnan(frac_alpha_best_n(alpha==alpha_array)))
                    frac_alpha_best_n(alpha==alpha_array)=1000;
                end
                Z=[Alls_alpha(:,end) train_data(:,end)];
                for i=1:K
                    cluster_alpha=Z(Z(:,1)==i,:);
                    for j=1:K
                        cnt_alpha(i,j)=sum(cluster_alpha(:,2)==j);
                        percent_alpha(i,j)=cnt_alpha(i,j);
                    end
                end
                if (K==2)
                    sum1=percent_alpha(1,1)+percent_alpha(2,2);
                    sum2=percent_alpha(1,2)+percent_alpha(2,1);
                    if(sum1>sum2)
                        True_alpha_n(rpt,alpha==alpha_array)=sum1/sz(1);
                    else
                        True_alpha_n(rpt,alpha==alpha_array)=sum2/sz(1);
                    end
                end
                iter_alpha(rpt)=count_alpha_n(alpha==alpha_array);
                PMI_alpha(rpt)=PMI_first;
            end
            frac_alpha=frac_alpha_best_n(alpha==alpha_array);
        end
        %******** Alpha with Neg   *************%
        Alls_alpha=train_data;
        Alls_alpha_f=Alls_rab;
        Alls_alpha_first=train_data;
        for i=1:K
            prior_alpha_first(:,i) = HMM_priors(:,i);
            transmat_alpha_first(:,:,i) = HMM_trans(:,:,i);
            obsmat_alpha_first(:,:,i) = HMM_obs(:,:,i);
        end
        for alpha=alpha_array
            Alls_alpha(:,end)=Alls_alpha_f(:,end);
            for i=1:K
                prior_alpha(:,i)=prior_alpha_first(:,i);
                transmat_alpha(:,:,i)=transmat_alpha_first(:,:,i);
                obsmat_alpha(:,:,i)=obsmat_alpha_first(:,:,i);
                [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
            end
            Alls_alpha_first=train_data;
            count_alpha_neg(alpha==alpha_array)=0;
            frac_alpha_first=100;
            PMI_first=-100;
            PMI_second=-10;
            while(PMI_second>PMI_first && count_alpha_neg(alpha==alpha_array)<max_loop)
                count_alpha_neg(alpha==alpha_array)=count_alpha_neg(alpha==alpha_array)+1;
                Alls_alpha_first=Alls_alpha;
                for i=1:sz(1)
                    [L1_alpha L2_alpha]=Measure_Matrix(prior_alpha,transmat_alpha,obsmat_alpha,Alls_alpha,Alls_alpha(i,:),HMM_priors(:,i),HMM_trans(:,:,i),HMM_obs(:,:,i));
                    [L_S,L_KLS,L_BP]=compute_distance(L1_alpha,L2_alpha);
                    Measure=L_S;
                    [~,c]=find(Measure==max(Measure));
                    if(size(c,2)>0)
                        Alls_alpha(i,T+1)=c(1);
                    end
                end
                for i=1:K
                    [prior_alpha,transmat_alpha,obsmat_alpha]=Merge_Clusters_alpha(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha,HMM_priors,HMM_trans,HMM_obs,alpha);
                end
                obsmat_alpha=Negative_Obs_alpha(obsmat_alpha,alpha);
                PMI_first=PMI_second;
                PMI_neg(alpha==alpha_array,count_alpha_neg(alpha==alpha_array))=Computer_PMI(Alls_alpha,prior_alpha,transmat_alpha,obsmat_alpha);
                PMI_second=PMI_neg(alpha==alpha_array,count_alpha_neg(alpha==alpha_array));
            end
            Alls_alpha=Alls_alpha_first;
            for i=1:K
                dist_in_alpha(alpha==alpha_array,in_rpt,i)=Inter_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
                dist_out_alpha(alpha==alpha_array,in_rpt,i)=Outer_Cluster_Dist(Alls_alpha,i,prior_alpha,transmat_alpha,obsmat_alpha);
            end
            frac_alpha_neg(in_rpt,alpha==alpha_array)=sum(dist_in_alpha(alpha==alpha_array,in_rpt,:))/sum(dist_out_alpha(alpha==alpha_array,in_rpt,:));
            if((in_rpt>1 && frac_alpha_neg(in_rpt,alpha==alpha_array)<frac_alpha_best_neg(alpha==alpha_array) && ~isnan(frac_alpha_neg(in_rpt,alpha==alpha_array)))|| in_rpt==1)
                frac_alpha_best_neg(alpha==alpha_array)=frac_alpha_neg(in_rpt,alpha==alpha_array);
                if(isnan(frac_alpha_best_neg(alpha==alpha_array)))
                    frac_alpha_best_neg(alpha==alpha_array)=1000;
                end
                Z=[Alls_alpha(:,end) train_data(:,end)];
                for i=1:K
                    cluster_alpha=Z(Z(:,1)==i,:);
                    for j=1:K
                        cnt_alpha(i,j)=sum(cluster_alpha(:,2)==j);
                        percent_alpha(i,j)=cnt_alpha(i,j);
                    end
                end
                if (K==2)
                    sum1=percent_alpha(1,1)+percent_alpha(2,2);
                    sum2=percent_alpha(1,2)+percent_alpha(2,1);
                    if(sum1>sum2)
                        True_alpha_neg(rpt,alpha==alpha_array)=sum1/sz(1);
                    else
                        True_alpha_neg(rpt,alpha==alpha_array)=sum2/sz(1);
                    end
                end
                iter_alpha_neg(rpt)=count_alpha_neg(alpha==alpha_array);
                PMI_alpha_neg(rpt)=PMI_first;            
            end
            frac_alpha_neg=frac_alpha_best_neg(alpha==alpha_array);
        end
    end
end
Rabiner=mean(True_Rab,2)
Ensemble=mean(True_Ens,2)
Alpha_normal=mean(True_alpha_n,1)
Alpha_justNeg=mean(True_alpha_neg,1)





